{$if not def LIBRARIES_AMIGAGUIDE_H} CONST LIBRARIES_AMIGAGUIDE_H=1;

{ ************************************************************************
  ** KickPascal-Include-Datei "libraries/amigaguide.h" zu Kickstart 3.0 **
  ************************************************************************ }

{$if not def EXEC_LISTS_H;incl "exec/lists.h";endif}
{$if not def EXEC_NODES_H;incl "exec/nodes.h";endif}
{$if not def EXEC_SEMAPHORES_H;incl "exec/semaphores.h";endif}
{$if not def INTUITION_INTUITION_H;incl "intuition/intuition.h";endif}
{$if not def INTUITION_SCREENS_H;incl "intuition/screens.h";endif}
{$if not def INTUITION_CLASSUSR_H;incl "intuition/classusr.h";endif}
{$if not def DOS_DOS_H;incl "dos/dos.h";endif}
{$if not def UTILITY_TAGITEM_H;incl "utility/tagitem.h";endif}

{$if not def APSH_TOOL_ID}
 
CONST
 APSH_TOOL_ID = 11000;
 StartupMsgID           = (APSH_TOOL_ID+1);
 LoginToolID            = (APSH_TOOL_ID+2);
 LogoutToolID           = (APSH_TOOL_ID+3);
 ShutdownMsgID          = (APSH_TOOL_ID+4);
 ActivateToolID         = (APSH_TOOL_ID+5);
 DeactivateToolID       = (APSH_TOOL_ID+6);
 ActiveToolID           = (APSH_TOOL_ID+7);
 InactiveToolID         = (APSH_TOOL_ID+8);
 ToolStatusID           = (APSH_TOOL_ID+9);
 ToolCmdID              = (APSH_TOOL_ID+10);
 ToolCmdReplyID         = (APSH_TOOL_ID+11);
 ShutdownToolID         = (APSH_TOOL_ID+12);

{$endif}

CONST
 AGA_Dummy      = (TAG_USER);
 AGA_Path       = (AGA_Dummy + 1);
 AGA_XRefList   = (AGA_Dummy + 2);
 AGA_Activate   = (AGA_Dummy + 3);
 AGA_Context    = (AGA_Dummy + 4);
 AGA_HelpGroup  = (AGA_Dummy + 5);

TYPE AMIGAGUIDECONTEXT = Ptr;

TYPE
 p_AmigaGuideMsg = ^AmigaGuideMsg;
 AmigaGuideMsg = RECORD
  agm_Msg       : Message;
  agm_Type      : Long;
  agm_Data      : Ptr;
  agm_DSize     : Long;
  agm_DType     : Long;
  agm_Pri_Ret   : Long;
  agm_Sec_Ret   : Long;
  agm_System1   : Ptr;
  agm_System2   : Ptr;
 end;
 
 p_NewAmigaGuide = ^NewAmigaGuide;
 NewAmigaGuide = RECORD
  nag_Lock      : BPTR;
  nag_Name      : Str;
  nag_Screen    : p_Screen;
  nag_PubScreen : Str;
  nag_HostPort  : Str;
  nag_ClientPort: Str;
  nag_BaseName  : Str;
  nag_Flags     : Long;
  nag_Context   : Ptr;
  nag_Node      : Str;
  nag_Line      : LongInt;
  nag_Extens    : p_TagItem;
  nag_Client    : Ptr;
 end;

CONST
 HTF_LOAD_INDEX = $00001;
 HTF_LOAD_ALL   = $00002;
 HTF_CACHE_NODE = $00004;
 HTF_CACHE_DB   = $00008;
 HTF_UNIQUE     = $08000;
 HTF_NOACTIVATE = $10000;

 HTFC_SYSGADS   = $80000000;

 HTH_OPEN       = 0;
 HTH_CLOSE      = 1;

 HTERR_NOT_ENOUGH_MEMORY        = 100;
 HTERR_CANT_OPEN_DATABASE       = 101;
 HTERR_CANT_FIND_NODE           = 102;
 HTERR_CANT_OPEN_NODE           = 103;
 HTERR_CANT_OPEN_WINDOW         = 104;
 HTERR_INVALID_COMMAND          = 105;
 HTERR_CANT_COMPLETE            = 106;
 HTERR_PORT_CLOSED              = 107;
 HTERR_CANT_CREATE_PORT         = 108;
 HTERR_KEYWORD_NOT_FOUND        = 113;

TYPE
 p_XRef = ^XRef;
 XRef = RECORD
  xr_Node       : Node;
  xr_Pad        : Word;
  xr_DF         : Ptr;
  xr_File       : Str;
  xr_Name       : Str;
  xr_Line       : LongInt;
 end;

CONST
 XRSIZE = sizeof(XRef);

 XR_GENERIC     = 0;
 XR_FUNCTION    = 1;
 XR_COMMAND     = 2;
 XR_INCLUDE     = 3;
 XR_MACRO       = 4;
 XR_STRUCT      = 5;
 XR_FIELD       = 6;
 XR_TYPEDEF     = 7;
 XR_DEFINE      = 8;
 
TYPE
 p_AmigaGuideHost = ^AmigaGuideHost; 
 AmigaGuideHost = RECORD
  agh_Dispatch  : Hook;
  agh_Reserved  : Long;
  agh_Flags     : Long;
  agh_UseCnt    : Long;
  agh_SystemData: Ptr;
  agh_UserData  : Ptr;
 end;
 
CONST
 HM_FINDNODE    =  1;
 HM_OPENNODE    =  2;
 HM_CLOSENODE   =  3;
 HM_EXPUNGE     = 10;

TYPE
 p_opFindHost = ^opFindHost;
 opFindHost = RECORD
  MethodID      : Long;
  ofh_Attrs     : p_TagItem;
  ofh_Node      : Str;
  ofh_TOC       : Str;
  ofh_Title     : Str;
  ofh_Next      : Str;
  ofh_Prev      : Str;
 end;
 
 p_opNodeIO = ^opNodeIO;
 opNodeIO = RECORD
  MethodID      : Long;
  onm_Attrs     : p_TagItem;
  onm_Node      : Str;
  onm_FileName  : Str;
  onm_DocBuffer : Str;
  onm_BuffLen   : Long;
  onm_Flags     : Long;
 end; 
 
CONST
 HTNF_KEEP	= $01;

 HTNF_RESERVED1	= $02;
 HTNF_RESERVED2	= $04;
 HTNF_ASCII	= $08;
 HTNF_RESERVED3	= $10;
 HTNF_CLEAN	= $20;
 HTNF_DONE	= $40;

 HTNA_Screen    = (TAG_USER + 1);
 HTNA_Pens      = (TAG_USER + 2);
 HTNA_Rectangle = (TAG_USER + 3);

TYPE
 p_opExpungeNode = ^opExpungeNode;
 opExpungeNode = RECORD
  MethodID      : Long;
  oen_Attrs     : p_TagItem;
 end;

{$endif}
