{$if not def LIBRARIES_ASL_H} CONST LIBRARIES_ASL_H=1;

{ *****************************************************************
  ** KickPascal-Include-Datei "libraries/asl.h" zu Kickstart 3.0 **
  ***************************************************************** }

TYPE p_FontRequester       = ^FontRequester;
TYPE p_FileRequester       = ^FileRequester;
TYPE p_ScreenModeRequester = ^ScreenModeRequester;

{$if not def EXEC_LISTS_H;incl "exec/lists.h";endif}
{$if not def EXEC_LIBRARIES_H;incl "exec/libraries.h";endif}
{$if not def UTILITY_HOOKS_H;incl "utility/hooks.h";endif}
{$if not def UTILITY_TAGITEM_H;incl "utility/tagitem.h";endif}
{$if not def WBArg;incl "workbench/startup.h";endif}
{$if not def GRAPHICS_TEXT_H;incl "graphics/text.h";endif}


CONST AslName = "asl.library";

CONST
 ASL_FileRequest         = 0;
 ASL_FontRequest         = 1;
 ASL_ScreenModeRequester = 2;


TYPE FileRequester = RECORD
 rf_Reserved1 : Ptr;
 rf_File      : Str;
 rf_Dir       : Str;
 rf_Reserved2 : Ptr;
 rf_Reserved3 : Byte;
 rf_Reserved4 : Byte;
 rf_Reserved5 : Ptr;
 rf_LeftEdge  : Integer;
 rf_TopEdge   : Integer;
 rf_Width     : Integer;
 rf_Height    : Integer;
 rf_Reserved6 : Integer;
 rf_NumArgs   : LongInt;
 rf_ArgList   : p_WBArg;
 rf_UserData  : Ptr;
 rf_Reserved7 : Ptr;
 rf_Reserved8 : Ptr;
 rf_Pat       : Str;
END;

CONST
 FRB_FILTERFUNC     = 7;
 FRB_INTUIFUNC      = 6;
 FRB_DOSAVEMODE     = 5;
 FRB_PRIVATEIDCMP   = 4;
 FRB_DOMULTISELECT  = 3;
 FRB_DOPATTERNS     = 0;

CONST
 FRF_FILTERFUNC     = $80;
 FRF_INTUIFUNC      = $40;
 FRF_DOSAVEMODE     = $20;
 FRF_PRIVATEIDCMP   = $10;
 FRF_DOMULTISELECT  = $8;
 FRF_DOPATTERNS     = $1;

CONST
 FRB_DRAWERSONLY   = 0;
 FRB_FILTERDRAWERS = 1;
 FRB_REJECTICONS   = 2;

CONST
 FRF_DRAWERSONLY   = $1;
 FRF_FILTERDRAWERS = $2;
 FRF_REJECTICONS   = $4;

CONST
 ASL_TB                = TAG_USER+$80000;

 ASLFR_TitleText       = ASL_TB+1;
 ASLFR_Window          = ASL_TB+2;
 ASLFR_InitialLeftEdge = ASL_TB+3;
 ASLFR_InitialTopEdge  = ASL_TB+4;
 ASLFR_InitialWidth    = ASL_TB+5;
 ASLFR_InitialHeight   = ASL_TB+6;
 ASLFR_HookFunc        = ASL_TB+7;
 ASLFR_InitialFile     = ASL_TB+8;
 ASLFR_InitialDrawer   = ASL_TB+9;
 ASLFR_InitialPattern  = ASL_TB+10;
 ASLFR_PositiveText    = ASL_TB+18;
 ASLFR_NegativeText    = ASL_TB+19;
 ASLFR_Flags1          = ASL_TB+20;
 ASLFR_Flags2          = ASL_TB+22;
 ASLFR_Screen          = ASL_TB+40;
 ASLFR_PubScreenName   = ASL_TB+41;
 ASLFR_PrivateIDCMP    = ASL_TB+42;
 ASLFR_SleepWindow     = ASL_TB+43;
 ASLFR_DoSaveMode      = ASL_TB+44;
 ASLFR_DoMultiSelect   = ASL_TB+45;
 ASLFR_DoPatterns      = ASL_TB+46;
 ASLFR_DrawersOnly     = ASL_TB+47;
 ASLFR_FilterFunc      = ASL_TB+49;
 ASLFR_Locale          = ASL_TB+50;
 ASLFR_TextAttr        = ASL_TB+51;
 ASLFR_UserData        = ASL_TB+52;
 ASLFR_RejectIcons     = ASL_TB+60;
 ASLFR_RejectPattern   = ASL_TB+61;
 ASLFR_AcceptPattern   = ASL_TB+62;
 ASLFR_FilterDrawers   = ASL_TB+63;
 ASLFR_IntuiMsgFunc    = ASL_TB+70;


TYPE FontRequester = RECORD
 fo_Reserved1 : ARRAY[0..1] OF Ptr;
 fo_Attr      : TextAttr;
 fo_FrontPen  : Byte;
 fo_BackPen   : Byte;
 fo_DrawMode  : Byte;
 fo_UserData  : Ptr;
END;

CONST
 FOB_DOFRONTPEN     = 0;
 FOB_DOBACKPEN      = 1;
 FOB_DOSTYLE        = 2;
 FOB_DODRAWMODE     = 3;
 FOB_FIXEDWIDTHONLY = 4;
 FOB_PRIVATEIDCMP   = 5;
 FOB_INTUIFUNC      = 6;
 FOB_FILTERFUNC     = 7;

 FOF_DOFRONTPEN     = $1;
 FOF_DOBACKPEN      = $2;
 FOF_DOSTYLE        = $4;
 FOF_DODRAWMODE     = $8;
 FOF_FIXEDWIDTHONLY = $10;
 FOF_PRIVATEIDCMP   = $20;
 FOF_INTUIFUNC      = $40;
 FOF_FILTERFUNC     = $80;

CONST
 ASLFO_TitleText       = ASL_TB+1;
 ASLFO_Window          = ASL_TB+2;
 ASLFO_InitialLeftEdge = ASL_TB+3;
 ASLFO_InitialTopEdge  = ASL_TB+4;
 ASLFO_InitialWidth    = ASL_TB+5;
 ASLFO_InitialHeight   = ASL_TB+6;
 ASLFO_HookFunc        = ASL_TB+7;
 ASLFO_InitialName     = ASL_TB+10;
 ASLFO_InitialSize     = ASL_TB+11;
 ASLFO_InitialStyle    = ASL_TB+12;
 ASLFO_InitialFlags    = ASL_TB+13;
 ASLFO_InitialFrontPen = ASL_TB+14;
 ASLFO_InitialBackPen  = ASL_TB+15;
 ASLFO_MinHeight       = ASL_TB+16;
 ASLFO_MaxHeight       = ASL_TB+17;
 ASLFO_PositiveText    = ASL_TB+18;
 ASLFO_NegativeText    = ASL_TB+19;
 ASLFO_Flags           = ASL_TB+20;
 ASLFO_Screen          = ASL_TB+40;
 ASLFO_PubScreenName   = ASL_TB+41;
 ASLFO_PrivateIDCMP    = ASL_TB+42;
 ASLFO_SleepWindow     = ASL_TB+43;
 ASLFO_DoFrontPen      = ASL_TB+44;
 ASLFO_DoBackPen       = ASL_TB+45;
 ASLFO_DoStyle         = ASL_TB+46;
 ASLFO_DoDrawMode      = ASL_TB+47;
 ASLFO_FixedWidthOnly  = ASL_TB+48;
 ASLFO_FilterFunc      = ASL_TB+49;
 ASLFO_Locale          = ASL_TB+50;
 ASLFO_TextAttr        = ASL_TB+51;
 ASLFO_UserData        = ASL_TB+52;
 ASLFO_InitialDrawMode = ASL_TB+59;
 ASLFO_IntuiMsgFunc    = ASL_TB+70;


TYPE ScreenModeRequester = RECORD
 sm_DisplayID     : Long;
 sm_DisplayWidth  : Long;
 sm_DisplayHeight : Long;
 sm_DisplayDepth  : word;
 sm_OverscanType  : word;
 sm_AutoScroll    : boolean;
 sm_BitMapWidth   : long;
 sm_BitMapHeight  : long;
 sm_LeftEdge      : word;
 sm_TopEdge       : word;
 sm_Width         : word;
 sm_Height        : word;
 sm_InfoOpened    : boolean;
 sm_InfoLeftEdge  : word;
 sm_InfoTopEdge   : word;
 sm_InfoWidth     : word;
 sm_InfoHeight    : word;
 sm_UserData      : ptr;
END;

CONST
 ASLSM_TitleText       = ASL_TB+1;
 ASLSM_Window          = ASL_TB+2;
 ASLSM_InitialLeftEdge = ASL_TB+3;
 ASLSM_InitialTopEdge  = ASL_TB+4;
 ASLSM_InitialWidth    = ASL_TB+5;
 ASLSM_InitialHeight   = ASL_TB+6;
 ASLSM_PositiveText    = ASL_TB+18;
 ASLSM_NegativeText    = ASL_TB+19;
 ASLSM_Screen          = ASL_TB+40;
 ASLSM_PubScreenName   = ASL_TB+41;
 ASLSM_PrivateIDCMP    = ASL_TB+42;
 ASLSM_SleepWindow     = ASL_TB+43;
 ASLSM_Locale          = ASL_TB+50;
 ASLSM_TextAttr        = ASL_TB+51;
 ASLSM_UserData        = ASL_TB+52;
 ASLSM_IntuiMsgFunc    = ASL_TB+70;
 ASLSM_InitialDisplayID     = ASL_TB+100;
 ASLSM_InitialDisplayWidth  = ASL_TB+101;
 ASLSM_InitialDisplayHeight = ASL_TB+102;
 ASLSM_InitialDisplayDepth  = ASL_TB+103;
 ASLSM_InitialOverscanType  = ASL_TB+104;
 ASLSM_InitialAutoScroll    = ASL_TB+105;
 ASLSM_InitialInfoOpened    = ASL_TB+106;
 ASLSM_InitialInfoLeftEdge  = ASL_TB+107;
 ASLSM_InitialInfoTopEdge   = ASL_TB+108;
 ASLSM_DoWidth         = ASL_TB+109;
 ASLSM_DoHeight        = ASL_TB+110;
 ASLSM_DoDepth         = ASL_TB+111;
 ASLSM_DoOverscanType  = ASL_TB+112;
 ASLSM_DoAutoScroll    = ASL_TB+113;
 ASLSM_PropertyFlags   = ASL_TB+114;
 ASLSM_PropertyMask    = ASL_TB+115;
 ASLSM_MinWidth        = ASL_TB+116;
 ASLSM_MaxWidth        = ASL_TB+117;
 ASLSM_MinHeight       = ASL_TB+118;
 ASLSM_MaxHeight       = ASL_TB+119;
 ASLSM_MinDepth        = ASL_TB+120;
 ASLSM_MaxDepth        = ASL_TB+121;
 ASLSM_FilterFunc      = ASL_TB+122;
 ASLSM_CustomSMList    = ASL_TB+123;

(* alte V37 Konstaten (sollten nicht mehr benutzt werden!) *)

CONST
 FILB_DOWILDFUNC    = 7;
 FILB_DOMSGFUNC     = 6;
 FILB_SAVE          = 5;
 FILB_NEWIDCMP      = 4;
 FILB_MULTISELECT   = 3;
 FILB_PATGAD        = 0;

CONST
 FILF_DOWILDFUNC    = $80;
 FILF_DOMSGFUNC     = $40;
 FILF_SAVE          = $20;
 FILF_NEWIDCMP      = $10;
 FILF_MULTISELECT   = $8;
 FILF_PATGAD        = $1;

CONST
 FIL1B_NOFILES     = 0;
 FIL1B_MATCHDIRS   = 1;

CONST
 FIL1F_NOFILES     = $1;
 FIL1F_MATCHDIRS   = $2;

CONST
 FONB_FRONTCOLOR = 0;
 FONB_BACKCOLOR  = 1;
 FONB_STYLES     = 2;
 FONB_DRAWMODE   = 3;
 FONB_FIXEDWIDTH = 4;
 FONB_NEWIDCMP   = 5;
 FONB_DOMSGFUNC  = 6;
 FONB_DOWILDFUNC = 7;

 FONF_FRONTCOLOR = $1;
 FONF_BACKCOLOR  = $2;
 FONF_STYLES     = $4;
 FONF_DRAWMODE   = $8;
 FONF_FIXEDWIDTH = $10;
 FONF_NEWIDCMP   = $20;
 FONF_DOMSGFUNC  = $40;
 FONF_DOWILDFUNC = $80;

CONST
 ASL_Dummy      = TAG_USER+$80000;

 ASL_Hail       = ASL_Dummy+1;
 ASL_Window     = ASL_Dummy+2;
 ASL_LeftEdge   = ASL_Dummy+3;
 ASL_TopEdge    = ASL_Dummy+4;
 ASL_Width      = ASL_Dummy+5;
 ASL_Height     = ASL_Dummy+6;
 ASL_HookFunc   = ASL_Dummy+7;
 ASL_File       = ASL_Dummy+8;
 ASL_Dir        = ASL_Dummy+9;

 ASL_FontName   = ASL_Dummy+10;
 ASL_FontHeight = ASL_Dummy+11;
 ASL_FontStyles = ASL_Dummy+12;
 ASL_FontFlags  = ASL_Dummy+13;
 ASL_FrontPen   = ASL_Dummy+14;
 ASL_BackPen    = ASL_Dummy+15;
 ASL_MinHeight  = ASL_Dummy+16;
 ASL_MaxHeight  = ASL_Dummy+17;

 ASL_OKText     = ASL_Dummy+18;
 ASL_CancelText = ASL_Dummy+19;
 ASL_FuncFlags  = ASL_Dummy+20;

 ASL_ModeList   = ASL_Dummy+21;
 ASL_ExtFlags1  = ASL_Dummy+22;

 ASL_Pattern    = ASL_FontName;

{$endif}
