{$if not def LIBRARIES_CONFIGREGS_H} CONST LIBRARIES_CONFIGREGS_H=0;

{ ************************************************************************
  ** KickPascal-Include-Datei "libraries/configregs.h" zu Kickstart 3.0 **
  ************************************************************************ }

TYPE p_ExpansionRom = ^ExpansionRom;
TYPE p_DiagArea = ^DiagArea;
TYPE p_ExpansionControl = ^ExpansionControl;


TYPE ExpansionRom = RECORD
 er_Type         : Byte;
 er_Product      : Byte;
 er_Flags        : Byte;
 er_Reserved03   : Byte;
 er_Manufacturer : Word;
 er_SerialNumber : Long;
 er_InitDiagVec  : Word;
 er_Reserved0c   : Byte;
 er_Reserved0d   : Byte;
 er_Reserved0e   : Byte;
 er_Reserved0f   : Byte;
END;

TYPE ExpansionControl = RECORD
 ec_Interrupt   : Byte;
 ec_Z3_HighBase : Byte;
 ec_BaseAddress : Byte;
 ec_Shutup      : Byte;
 ec_Reserved14  : Byte;
 ec_Reserved15  : Byte;
 ec_Reserved16  : Byte;
 ec_Reserved17  : Byte;
 ec_Reserved18  : Byte;
 ec_Reserved19  : Byte;
 ec_Reserved1a  : Byte;
 ec_Reserved1b  : Byte;
 ec_Reserved1c  : Byte;
 ec_Reserved1d  : Byte;
 ec_Reserved1e  : Byte;
 ec_Reserved1f  : Byte;
END;

CONST
 E_SLOTSIZE  = $10000;
 E_SLOTMASK  = $ffff;
 E_SLOTSHIFT = 16;

CONST
 E_EXPANSIONBASE     = $00e80000;
 EZ3_EXPANSIONBASE   = $ff000000;

 E_EXPANSIONSIZE     = $00080000;
 E_EXPANSIONSLOTS    = 8;

 E_MEMORYBASE        = $00200000;
 E_MEMORYSIZE        = $00800000;
 E_MEMORYSLOTS       = 128;

 EZ3_CONFIGAREA      = $40000000;
 EZ3_CONFIGAREAEND   = $7FFFFFFF;
 EZ3_SIZEGRANULARITY = $00080000;


 ERT_TYPEMASK        = $c0;
 ERT_TYPEBIT         = 6;
 ERT_TYPESIZE        = 2;
 ERT_NEWBOARD        = $c0;
 ERT_ZORROII         = ERT_NEWBOARD;
 ERT_ZORROIII        = $80;

 ERTB_MEMLIST        = 5;
 ERTB_DIAGVALID      = 4;
 ERTB_CHAINEDCONFIG  = 3;

 ERTF_MEMLIST        = $20;
 ERTF_DIAGVALID      = $10;
 ERTF_CHAINEDCONFIG  = $8;

 ERT_MEMMASK         = $07;
 ERT_MEMBIT          = 0;
 ERT_MEMSIZE         = 3;

 ERFF_MEMSPACE       = $80;
 ERFB_MEMSPACE       = 7;

 ERFF_NOSHUTUP       = $40;
 ERFB_NOSHUTUP       = 6;

 ERFF_EXTENDED       = $20;
 ERFB_EXTENDED       = 5;

 ERFF_ZORRO_III      = $10;
 ERFB_ZORRO_III      = 4;

 ERT_Z3_SSMASK       = $0F;
 ERT_Z3_SSBIT        = 0;
 ERT_Z3_SSSIZE       = 4;

 ECIB_INTENA         = 1;
 ECIB_RESET          = 3;
 ECIB_INT2PEND       = 4;
 ECIB_INT6PEND       = 5;
 ECIB_INT7PEND       = 6;
 ECIB_INTERRUPTING   = 7;

 ECIF_INTENA         = $2;
 ECIF_RESET          = $8;
 ECIF_INT2PEND       = $10;
 ECIF_INT6PEND       = $20;
 ECIF_INT7PEND       = $40;
 ECIF_INTERRUPTING   = $80;


TYPE DiagArea = RECORD
 da_Config     : Byte; 
 da_Flags      : Byte;
 da_Size       : Word;
 da_DiagPoint  : Word;
 da_BootPoint  : Word;
 da_Name       : Word;
 da_Reserved01 : Word;
 da_Reserved02 : Word;
END;

CONST
 DAC_BUSWIDTH   = $C0;
 DAC_NIBBLEWIDE = $00;
 DAC_BYTEWIDE   = $40;
 DAC_WORDWIDE   = $80;

 DAC_BOOTTIME   = $30;
 DAC_NEVER      = $00;
 DAC_CONFIGTIME = $10;
 DAC_BINDTIME   = $20;

{$endif}
