{$if not def LIBRARIES_GADTOOLS_H}CONST LIBRARIES_GADTOOLS_H=0;

{ **********************************************************************
  ** KickPascal-Include-Datei "libraries/gadtools.h" zu Kickstart 3.0 **
  ********************************************************************** }

TYPE p_NewGadget = ^NewGadget;
TYPE p_NewMenu = ^NewMenu;

{$if not def UTILITY_TAGITEM_H;incl "utility/tagitem.h";endif}
{$if not def INTUITION_INTUITION_H;incl "intuition/intuition.h";endif}

CONST
 GENERIC_KIND  = 0;
 BUTTON_KIND   = 1;
 CHECKBOX_KIND = 2;
 INTEGER_KIND  = 3;
 LISTVIEW_KIND = 4;
 MX_KIND       = 5;
 NUMBER_KIND   = 6;
 CYCLE_KIND    = 7;
 PALETTE_KIND  = 8;
 SCROLLER_KIND = 9;

 SLIDER_KIND   = 11;
 STRING_KIND   = 12;
 TEXT_KIND     = 13;

 NUM_KINDS     = 14;

CONST
 GADTOOLBIT  = $8000;
 GADTOOLMASK = $7FFF;

CONST
 ARROWIDCMP    = (IDCMP_GADGETUP or IDCMP_GADGETDOWN or IDCMP_INTUITICKS or IDCMP_MOUSEBUTTONS);
 BUTTONIDCMP   = IDCMP_GADGETUP;
 CHECKBOXIDCMP = IDCMP_GADGETUP;
 INTEGERIDCMP  = IDCMP_GADGETUP;
 LISTVIEWIDCMP = (IDCMP_GADGETUP or IDCMP_GADGETDOWN or IDCMP_MOUSEMOVE or ARROWIDCMP);
 MXIDCMP       = IDCMP_GADGETDOWN;
 NUMBERIDCMP   = 0;
 CYCLEIDCMP    = IDCMP_GADGETUP;
 PALETTEIDCMP  = IDCMP_GADGETUP;

 SCROLLERIDCMP = (IDCMP_GADGETUP or IDCMP_GADGETDOWN or IDCMP_MOUSEMOVE);
 SLIDERIDCMP   = (IDCMP_GADGETUP or IDCMP_GADGETDOWN or IDCMP_MOUSEMOVE);
 STRINGIDCMP   = IDCMP_GADGETUP;

 TEXTIDCMP     = 0;

TYPE NewGadget = RECORD
 ng_LeftEdge   : Integer;
 ng_TopEdge    : Integer;
 ng_Width      : Integer;
 ng_Height     : Integer;
 ng_GadgetText : Str;
 ng_TextAttr   : p_TextAttr;
 ng_GadgetID   : Word;
 ng_Flags      : Long;
 ng_VisualInfo : Ptr;
 ng_UserData   : Ptr;
END;

CONST
 PLACETEXT_LEFT  = $0001;
 PLACETEXT_RIGHT = $0002;
 PLACETEXT_ABOVE = $0004;
 PLACETEXT_BELOW = $0008;
 PLACETEXT_IN    = $0010;

 NG_HIGHLABEL    = $0020;

TYPE NewMenu = RECORD
 nm_Type          : Byte;
 nm_Pad           : Byte;
 nm_Label         : Str;
 nm_CommKey       : Str;
 nm_Flags         : Word;
 nm_MutualExclude : LongInt;
 nm_UserData      : Ptr;
END;

CONST
 NM_TITLE =  1;
 NM_ITEM  =  2;
 NM_SUB   =  3;
 NM_END   =  0;
 NM_IGNORE= 64;

CONST
 MENU_IMAGE = 128;
 IM_ITEM    = (NM_ITEM or MENU_IMAGE);
 IM_SUB     = (NM_SUB or MENU_IMAGE);

 NM_BARLABEL = -1; { Wert mu bei Einsatz in STR-Pointer gewandelt werden STR() }


CONST
 NM_MENUDISABLED = MENUENABLED;
 NM_ITEMDISABLED = ITEMENABLED;
 
 NM_COMMANDSTRING= COMMSEQ;

CONST NM_FLAGMASK     = (-1-COMMSEQ-ITEMTEXT-HIGHFLAGS);
      NM_FLAGMASK_V39 = (-1-ITEMTEXT-HIGHFLAGS);


 GTMENU_TRIMMED = $00000001;
 GTMENU_INVALID = $00000002;
 GTMENU_NOMEM   = $00000003;

CONST
 MX_WIDTH       = 17;
 MX_HEIGHT      =  9;
 
 CHECKBOX_WIDTH = 26;
 CHECKBOX_HEIGHT= 11;

CONST
 GT_TagBase       = TAG_USER+$80000;
 GTVI_NewWindow   = GT_TagBase+1;
 GTVI_NWTags      = GT_TagBase+2;
 GT_Private0      = GT_TagBase+3;
 GTCB_Checked     = GT_TagBase+4;
 GTLV_Top         = GT_TagBase+5;
 GTLV_Labels      = GT_TagBase+6;
 GTLV_ReadOnly    = GT_TagBase+7;
 GTLV_ScrollWidth = GT_TagBase+8;
 GTMX_Labels      = GT_TagBase+9;
 GTMX_Active      = GT_TagBase+10;
 GTTX_Text        = GT_TagBase+11;
 GTTX_CopyText    = GT_TagBase+12;
 GTNM_Number      = GT_TagBase+13;
 GTCY_Labels      = GT_TagBase+14;
 GTCY_Active      = GT_TagBase+15;
 GTPA_Depth       = GT_TagBase+16;
 GTPA_Color       = GT_TagBase+17;
 GTPA_ColorOffset = GT_TagBase+18;
 GTPA_IndicatorWidth  = GT_TagBase+19;
 GTPA_IndicatorHeight = GT_TagBase+20;
 GTSC_Top         = GT_TagBase+21;
 GTSC_Total       = GT_TagBase+22;
 GTSC_Visible     = GT_TagBase+23;
 GTSC_Overlap     = GT_TagBase+24;
{ *** GT_TagBase+25 bis GT_TagBase+37 reserviert *** }

 GTSL_Min         = GT_TagBase+38;
 GTSL_Max         = GT_TagBase+39;
 GTSL_Level       = GT_TagBase+40;
 GTSL_MaxLevelLen = GT_TagBase+41;
 GTSL_LevelFormat = GT_TagBase+42;
 GTSL_LevelPlace  = GT_TagBase+43;
 GTSL_DispFunc    = GT_TagBase+44;
 GTST_String      = GT_TagBase+45;
 GTST_MaxChars    = GT_TagBase+46;
 GTIN_Number      = GT_TagBase+47;
 GTIN_MaxChars    = GT_TagBase+48;
 GTMN_TextAttr    = GT_TagBase+49;
 GTMN_FrontPen    = GT_TagBase+50;
 GTBB_Recessed    = GT_TagBase+51;
 GT_VisualInfo    = GT_TagBase+52;
 GTLV_ShowSelected = GT_TagBase+53;
 GTLV_Selected    = GT_TagBase+54;
 GT_Reserved1     = GT_TagBase+56;
 GTTX_Border      = GT_TagBase+57;
 GTNM_Border      = GT_TagBase+58;
 GTSC_Arrows      = GT_TagBase+59;
 GTMN_Menu        = GT_TagBase+60;
 GTMX_Spacing     = GT_TagBase+61;

{ **** neu seit V37 **** }

 GTMN_FullMenu    = GT_TagBase+62;
 GTMN_SecondaryError = GT_TagBase+63;
 GT_Underscore    = GT_TagBase+64;
 GTST_EditHook    = GT_TagBase+55;
 GTIN_EditHook    = GTST_EditHook;

{ **** neu seit V39 **** }

 GTMN_Checkmark   = GT_TagBase+65;
 GTMN_AmigaKey    = GT_TagBase+66;
 GTMN_NewLookMenus= GT_TagBase+67;

 GTCB_Scaled      = GT_TagBase+68;
 GTMX_Scaled      = GT_TagBase+69;

 GTPA_NumColors   = GT_TagBase+70;
 GTMX_TitlePlace  = GT_TagBase+71;
 GTTX_FrontPen    = GT_TagBase+72;
 GTTX_BackPen     = GT_TagBase+73;
 GTTX_Justification= GT_TagBase+74;

 GTNM_FrontPen    = GT_TagBase+72;
 GTNM_BackPen     = GT_TagBase+73;
 GTNM_Justification= GT_TagBase+74;
 GTNM_Format      = GT_TagBase+75;
 GTNM_MaxNumberLen= GT_TagBase+76;

 GTBB_FrameType   = GT_TagBase+77;

 GTLV_MakeVisible = GT_TagBase+78;
 GTLV_ItemHeight  = GT_TagBase+79;

 GTSL_MaxPixelLen = GT_TagBase+80;
 GTSL_Justification= GT_TagBase+81;

 GTPA_ColorTable  = GT_TagBase+82;

 GTLV_CallBack    = GT_TagBase+83;
 GTLV_MaxPen      = GT_TagBase+84;

 GTTX_Clipped     = GT_TagBase+85;
 GTNM_Clipped     = GT_TagBase+85;

{ *** alte Deffinition, nicht mehr so benutzen *** }
 GT_Reserved0     = GTST_EditHook;

CONST
 GTJ_LEFT       = 0;
 GTJ_RIGHT      = 1;
 GTJ_CENTER     = 2;

CONST
 BBFT_BUTTON    = 1;
 BBFT_RIDGE     = 2;
 BBFT_ICONDROPBOX= 3;

CONST
 INTERWIDTH     = 8;
 INTERHEIGHT    = 4;

CONST
 NWAY_KIND   = CYCLE_KIND;
 NWAYIDCMP   = CYCLEIDCMP;
 GTNW_Labels = GTCY_Labels;
 GTNW_Active = GTCY_Active;

CONST
 LV_DRAW        =$202;
 LVCB_OK        = 1;
 LVCB_UNKNOWN   = 2;

 LVR_NORMAL     = 0;
 LVR_SELECTED   = 1;
 LVR_NORMALDISABLED   = 2;
 LVR_SELECTEDDISABLED = 8;
 
TYPE
 p_LVDrawMsg=^LVDrawMsg;
 LVDrawMsg=RECORD
  lvdm_MethodID : Long;
  lvdm_RastPort : p_RastPort;
  lvdm_DrawInfo : p_DrawInfo;
  lvdm_Bounds   : Rectangle;
  lvdm_State    : Long;
 end;

{$endif}
