{$if not def IFF_IFFPARSE_H} CONST IFF_IFFPARSE_H=0;

{ **********************************************************************
  ** KickPascal-Include-Datei "libraries/iffparse.h" zu Kickstart 3.0 **
  ********************************************************************** }

TYPE p_IFFHandle = ^IFFHandle;
TYPE p_IFFStreamCmd = ^IFFStreamCmd;
TYPE p_ContextNode = ^ContextNode;
TYPE p_LocalContextItem = ^LocalContextItem;
TYPE p_StoredProperty = ^StoredProperty;
TYPE p_CollectionItem = ^CollectionItem;
TYPE p_ClipboardHandle = ^ClipboardHandle;


{$if not def EXEC_LISTS_H;incl "exec/Lists.h";endif}
{$if not def EXEC_PORTS_H;incl "exec/Ports.h";endif}
{$if not def DEVICES_CLIPBOARD_H;incl "devices/clipboard.h";endif}

TYPE IFFHandle = RECORD
 iff_Stream : Long;
 iff_Flags  : Long
 iff_Depth  : LongInt;
 { private Felder ...}
END;

CONST
 IFFF_READ     = 0;
 IFFF_WRITE    = 1;
 IFFF_RWBITS   = 3;
 IFFF_FSEEK    = $2;
 IFFF_RSEEK    = $4;
 IFFF_RESERVED = $FFFF0000;

TYPE IFFStreamCmd = RECORD
 sc_Command : LongInt;
 sc_Buf     : Ptr;
 sc_NBytes  : LongInt;
END;

TYPE ContextNode = RECORD
 cn_Node : MinNode;
 cn_ID   : LongInt;
 cn_Type : LongInt;
 cn_Size : LongInt;
 cn_Scan : LongInt;
 { priate Felder ... }
END;

TYPE LocalContextItem = RECORD
 lci_Node  : MinNode;
 lci_ID    : Long;
 lci_Type  : Long;
 lci_Ident : Long;
 { priate Felder ... }
END;

TYPE StoredProperty = RECORD
 sp_Size : LongInt;
 sp_Data : Ptr;
END;

TYPE CollectionItem = RECORD
 ci_Next : p_CollectionItem;
 ci_Size : LongInt;
 ci_Data : Ptr;
END;

TYPE ClipboardHandle = RECORD
 cbh_Req         : IOClipReq;
 cbh_CBport      : MsgPort;
 cbh_SatisfyPort : MsgPort;
END;

CONST
 IFFERR_EOF        = -1;
 IFFERR_EOC        = -2;
 IFFERR_NOSCOPE    = -3;
 IFFERR_NOMEM      = -4;
 IFFERR_READ       = -5;
 IFFERR_WRITE      = -6;
 IFFERR_SEEK       = -7;
 IFFERR_MANGLED    = -8;
 IFFERR_SYNTAX     = -9;
 IFFERR_NOTIFF     = -10;
 IFFERR_NOHOOK     = -11;
 IFF_RETURN2CLIENT = -12;

{ Macro MAKE_ID wurde als FUNCTION in IFFPARSE_Functions.h
  angelegt, kann jedoch NICHT bei Konstantendefinition benutzt werden! }

CONST
 ID_FORM = $464F524D  { "FORM" };
 ID_LIST = $4C495354  { "LIST" };
 ID_CAT  = $43415420  { "CAT " };
 ID_PROP = $50524f50  { "PROP" };
 ID_NULL = $20202020  { "    " };

CONST
 IFFLCI_PROP         = $70726F70 { "prop" };
 IFFLCI_COLLECTION   = $636F6C6C { "coll" };
 IFFLCI_ENTRYHANDLER = $656E6864 { "enhd" };
 IFFLCI_EXITHANDLER  = $65786864 { "exhd" };

CONST
 IFFPARSE_SCAN    = 0;
 IFFPARSE_STEP    = 1;
 IFFPARSE_RAWSTEP = 2;

CONST
 IFFSLI_ROOT = 1;
 IFFSLI_TOP  = 2;
 IFFSLI_PROP = 3;

CONST IFFSIZE_UNKNOWN = -1;

CONST
 IFFCMD_INIT     = 0;
 IFFCMD_CLEANUP  = 1;
 IFFCMD_READ     = 2;
 IFFCMD_WRITE    = 3;
 IFFCMD_SEEK     = 4;
 IFFCMD_ENTRY    = 5;
 IFFCMD_EXIT     = 6;
 IFFCMD_PURGELCI = 7;

 IFFSCC_INIT    = IFFCMD_INIT;
 IFFSCC_CLEANUP = IFFCMD_CLEANUP;
 IFFSCC_READ    = IFFCMD_READ;
 IFFSCC_WRITE   = IFFCMD_WRITE;
 IFFSCC_SEEK    = IFFCMD_SEEK;

{$endif}
