{$if not def LIBRARIES_LOCALE_H} CONST LIBRARIES_LOCALE_H=1;

{ ********************************************************************
  ** KickPascal-Include-Datei "libraries/locale.h" zu Kickstart 3.0 **
  ******************************************************************** }

TYPE p_Locale       = ^Locale;
TYPE p_Catalog      = ^Catalog;
TYPE p_Char         = ^Char;
TYPE p_LocaleBase   = ^_LocaleBase;

{ if not def EXEC_EXEC_H;incl "exec/exec.h";endif}
{$if not def EXEC_NODES_H;incl "exec/nodes.h";endif}
{$if not def EXEC_LISTS_H;incl "exec/lists.h";endif}
{$if not def EXEC_LIBRARIES_H;incl "exec/libraries.h";endif}
{$if not def UTILITY_TAGITEM_H;incl "utility/tagitem.h";endif}

CONST LocaleName = "locale.library";

Const
  DAY_1    =  1;
  DAY_2    =  2;
  DAY_3    =  3;
  DAY_4    =  4;
  DAY_5    =  5;
  DAY_6    =  6;
  DAY_7    =  7;

  ABDAY_1  =  8;
  ABDAY_2  =  9;
  ABDAY_3  = 10;
  ABDAY_4  = 11;
  ABDAY_5  = 12;
  ABDAY_6  = 13;
  ABDAY_7  = 14;

  MON_1    = 15;
  MON_2    = 16;
  MON_3    = 17;
  MON_4    = 18;
  MON_5    = 19;
  MON_6    = 20;
  MON_7    = 21;
  MON_8    = 22;
  MON_9    = 23;
  MON_10   = 24;
  MON_11   = 25;
  MON_12   = 26;

  ABMON_1  = 27;
  ABMON_2  = 28;
  ABMON_3  = 29;
  ABMON_4  = 30;
  ABMON_5  = 31;
  ABMON_6  = 32;
  ABMON_7  = 33;
  ABMON_8  = 34;
  ABMON_9  = 35;
  ABMON_10 = 36;
  ABMON_11 = 37;
  ABMON_12 = 38;

  YESSTR   = 39;
  NOSTR    = 40;

  AM_STR   = 41;
  PM_STR   = 42;

  SOFTHYPHEN  = 43;
  HARDHYPHEN  = 44;

  OPENQUOTE   = 45;
  CLOSEQUOTE  = 46;

  YESTERDAYSTR = 47;
  TODAYSTR     = 48;
  TOMORROWSTR  = 49;
  FUTURESTR    = 50;

  MAXSTRMSG   = 51;


Type
  _LocaleBase = Record  { "_" ergnzt }
     lb_LibNode : _Library;
     lb_SysPatches : Boolean;
  end;

  Locale = Record
     loc_LocaleName      : Str;
     loc_LanguageName    : Str;
     loc_PrefLanguages   : Array[1..10] of Str;
     loc_Flags           : Long;

     loc_CodeSet         : Long;
     loc_CountryCode     : Long;
     loc_TelephoneCode   : Long;
     loc_GMTOOffset      : Long;
     loc_MeasuringSystem : Byte;
     loc_CalendarType    : Byte;
     loc_Reserved0       : Array[1..2] of Byte;

     loc_DateTimeFormat  : Str;
     loc_DateFormat      : Str;
     loc_TimeFormat      : Str;

     loc_ShortDateTimeFormat   : Str;
     loc_ShortDateFormat : Str;
     loc_ShortTimeFormat : Str;

     loc_DecimalPoint    : Str;
     loc_GroupSeparator  : Str;
     loc_FracGroupSeparator    : Str;
     loc_Grouping        : ^Byte;
     loc_FracGrouping    : ^Byte;

     loc_MonDecimalPoint : Str;
     loc_MonGroupSeparator     : Str;
     loc_MonFracGroupSeparator : Str;
     loc_MonGrouping     : ^Byte;
     loc_MonFracGrouping : ^Byte;
     loc_MonFracDigits   : Byte;
     loc_MonIntFracDigits: Byte;
     loc_Reserved1       : Array[1..2] of Byte;

     loc_MonCS           : Str;
     loc_MonSmallCS      : Str;
     loc_MonIntCS        : Str;

     loc_MonPositiveSign : Str;
     loc_MonPositiveSpaceSep   : Byte;
     loc_MonPositiveSignPos    : Byte;
     loc_MonPositiveCSPos: Byte;
     loc_Reserved2       : Byte;

     loc_MonNegativeSign : Str;
     loc_MonNegativeSpaceSep   : Byte;
     loc_MonNegativeSignPos    : Byte;
     loc_MonNegativeCSPos: Byte;
     loc_Reserved3       : Byte;
  end;

Const
  MS_ISO        =  0;
  MS_AMERICAN   =  1;
  MS_IMPERIAL   =  2;
  MS_BRITISH    =  3;

  CT_7SUN       =  0;
  CT_7MON       =  1;
  CT_7TUE       =  2;
  CT_7WED       =  3;
  CT_7THU       =  4;
  CT_7FRI       =  5;
  CT_7SAT       =  6;

  SS_NOSPACE    =  0;
  SS_SPACE      =  1;

  SP_PARENS     =  0;
  SP_PREC_ALL   =  1;
  SP_SUCC_ALL   =  2;
  SP_PREC_CURR  =  3;
  SP_SUCC_CURR  =  4;

  CSP_PRECEDES  =  0;
  CSP_SUCCEEDS  =  1;

  OC_TagBase         = TAG_USER + $90000;
  OC_BuiltInLanguage = OC_TagBase+1;
  OC_BuiltInCodeSet  = OC_TagBase+2;
  OC_Version         = OC_TagBase+3;
  OC_Language        = OC_TagBase+4;

  SC_ASCII    = 0;
  SC_COLLATE1 = 1;
  SC_COLLATE2 = 2;

Type
  Catalog = Record
     cat_Link     : Node;
     cat_Pad      : Word;
     cat_Language : Str;
     cat_CodeSet  : Long;
     cat_Version  : Word;
     cat_Revision : Word;
  end;
{$endif}
